3 ################################################################################
5 # The MIT License (MIT)
7 # Copyright (c) 2016 Stéphane Desneux <sdx@iot.bzh>
8 # (c) 2016 Jan-Simon Möller <jsmoeller@linuxfoundation.org>
10 # Permission is hereby granted, free of charge, to any person obtaining a copy
11 # of this software and associated documentation files (the "Software"), to deal
12 # in the Software without restriction, including without limitation the rights
13 # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
14 # copies of the Software, and to permit persons to whom the Software is
15 # furnished to do so, subject to the following conditions:
17 # The above copyright notice and this permission notice shall be included in
18 # all copies or substantial portions of the Software.
20 # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
21 # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
22 # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
23 # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
24 # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
25 # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
28 ################################################################################
30 # this script shouldn't be called directly, but through aglsetup.sh that will in
31 # turn execute (source) generated instructions back in the parent shell,
32 # whether it's bash, zsh, or any other supported shell
35 DEFAULT_MACHINE=qemux86-64
36 DEFAULT_BUILDDIR=./build
40 #SCRIPT=$(basename $BASH_SOURCE)
42 SCRIPTDIR=$(cd $(dirname $BASH_SOURCE) && pwd -P)
43 METADIR=$(cd $(dirname $BASH_SOURCE)/../.. && pwd -P)
45 function info() { echo "$@" >&2; }
46 function infon() { echo -n "$@" >&2; }
47 function error() { echo "ERROR: $@" >&2; return 1; }
48 function verbose() { [[ $VERBOSE == 1 ]] && echo "$@" >&2; return 0; }
49 function debug() { [[ $DEBUG == 1 ]] && echo "DEBUG: $@" >&2; return 0;}
51 info "------------ $SCRIPT: Starting"
53 #compute AGL_REPOSITORIES
54 AGL_REPOSITORIES=$(for x in $(ls -d $METADIR/*/templates/{machine,feature}); do echo $(basename $(dirname $(dirname $x))); done | sort -u)
56 function list_machines() {
58 for y in $(ls -d $METADIR/$x/templates/machine/* 2>/dev/null); do
64 function list_all_machines() {
65 for x in $AGL_REPOSITORIES; do
70 function validate_builddir() {
71 if [[ "$BUILDDIR" =~ [[:space:]] ]]; then
72 error "Build dir '$BUILDDIR' shouldn't contain any space"
74 debug "Build dir is valid"
77 function validate_machines() {
78 list_all_machines | sort | uniq -c | while read cnt machine; do
79 [[ $cnt == 1 ]] && continue
80 info "Machine $machine found in the following repositories:"
81 for x in $(ls -d $METADIR/*/templates/machine/$machine); do
84 error "Multiple machine templates are not allowed"
86 debug "Machines list has no duplicate."
89 function list_features() {
91 for y in $(ls -d $METADIR/$x/templates/feature/* 2>/dev/null); do
97 function list_all_features() {
98 for x in $AGL_REPOSITORIES; do
103 function validate_features() {
104 list_all_features | sort | uniq -c | while read cnt feature; do
105 [[ $cnt == 1 ]] && continue;
106 info "Feature $feature found in the following repositories:"
107 for x in $(ls -d $METADIR/*/templates/feature/$feature); do
110 error "Multiple feature templates are not allowed"
112 debug "Features list has no duplicate."
115 function find_machine_dir() {
117 for x in $AGL_REPOSITORIES; do
118 dir=$METADIR/$x/templates/machine/$machine
119 [[ -d $dir ]] && { echo $dir; return 0; }
124 function find_feature_dir() {
126 for x in $AGL_REPOSITORIES; do
127 dir=$METADIR/$x/templates/feature/$feature
128 [[ -d $dir ]] && { echo $dir; return 0; }
135 Usage: . $SCRIPT [options] [feature [feature [... ]]]
138 Compatibility: bash, zsh, ksh
141 -m|--machine <machine>
143 default: '$DEFAULT_MACHINE'
144 -b|--build <directory>
145 build directory to use
146 default: '$DEFAULT_BUILDDIR'
147 -s|--script <filename>
148 file where setup script is generated
149 default: none (no script)
151 flag to force overwriting any existing configuration
165 echo "Available machines:" >&2
166 for x in $AGL_REPOSITORIES; do
167 buf=$(list_machines $x)
168 [[ -z "$buf" ]] && continue
171 [[ $y == $DEFAULT_MACHINE ]] && def="* " || def=" "
177 echo "Available features:" >&2
178 for x in $AGL_REPOSITORIES; do
179 buf=$(list_features $x)
180 [[ -z "$buf" ]] && continue
182 for feature in $buf; do
183 print_feature="$feature"
184 featuredir=$(find_feature_dir $feature)
185 if [ -e $featuredir/included.dep ];then
186 print_feature="$print_feature :($(find_feature_dependency $feature $feature))"
188 echo " $print_feature"
194 function append_fragment() {
195 basefile=$1; shift # output file
196 f=$1; shift # input file
199 debug "adding fragment to $basefile: $f"
201 echo "# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #" >>$basefile
202 echo "# fragment { " >>$basefile
203 [[ -f $f ]] && echo "# $f" >>$basefile || true
205 [[ -n "$label" ]] && echo "$label" >>$basefile
206 [[ -f $f ]] && cat $f >>$basefile || true
208 echo "# }" >>$basefile
209 echo "# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #" >>$basefile
210 [[ -f $f ]] && echo $f >>$BUILDDIR/conf/fragments.log || true
213 function execute_setup() {
215 debug "Executing script $script"
217 [[ $DEBUG == 1 ]] && opts="$opts -x"
218 pushd $BUILDDIR &>/dev/null
219 $BASH $opts $script \
221 || { rc=$?; error "Script $script failed"; }
227 # process all fragments
228 FRAGMENTS_BBLAYERS=""
229 FRAGMENTS_LOCALCONF=""
231 function process_fragments() {
233 debug "processing fragments in dir $dir"
235 verbose " Searching fragments: $dir"
237 # lookup for files with priorities specified: something like xx_bblayers.conf.yyyyy.inc
238 for x in $(ls $dir/??[._]bblayers.conf*.inc 2>/dev/null); do
239 FRAGMENTS_BBLAYERS="$FRAGMENTS_BBLAYERS $(basename $x):$x"
240 verbose " priority $(basename $x | cut -c1-2): $(basename $x)"
243 # same for local.conf
244 for x in $(ls $dir/??[._]local.conf*.inc 2>/dev/null); do
245 FRAGMENTS_LOCALCONF="$FRAGMENTS_LOCALCONF $(basename $x):$x"
246 verbose " priority $(basename $x | cut -c1-2): $(basename $x)"
250 for x in $(ls $dir/??[._]setup*.sh 2>/dev/null); do
251 FRAGMENTS_SETUP="$FRAGMENTS_SETUP $(basename $x):$x"
252 verbose " priority $(basename $x | cut -c1-2): $(basename $x)"
257 function containsFeature () {
258 for feature in $1; do
259 [[ "$feature" == "$2" ]] && return 1;
264 function find_feature_dependency() {
266 featuredir=$(find_feature_dir $1)
268 if [ -e $featuredir/included.dep ]; then
269 dep_features="$(cat $featuredir/included.dep)"
270 for dep_feature in $dep_features; do
271 full_feature="$full_feature $res_dep_features"
272 res_dep_features="$res_dep_features $dep_feature"
273 if containsFeature $dep_feature $full_feature ; then
274 res_dep_features="$res_dep_features $(find_feature_dependency $dep_feature $full_feature)"
278 echo "$res_dep_features";
283 debug "Parsing arguments: $@"
284 TEMP=$(getopt -o m:b:s:fvdh --long machine:,builddir:,script:,force,verbose,debug,help -n $SCRIPT -- "$@")
285 [[ $? != 0 ]] && { usage; exit 1; }
290 ### default options values
291 MACHINE=$DEFAULT_MACHINE
292 BUILDDIR=$DEFAULT_BUILDDIR
298 -m|--machine) MACHINE=$2; shift 2;;
299 -b|--builddir) BUILDDIR=$2; shift 2;;
300 -s|--setupscript) SETUPSCRIPT=$2; shift 2;;
301 -f|--force) FORCE=1; shift;;
302 -v|--verbose) VERBOSE=1; shift;;
303 -d|--debug) VERBOSE=1; DEBUG=1; shift;;
304 -h|--help) HELP=1; shift;;
306 *) error "Arguments parsing error"; exit 1;;
310 [[ "$HELP" == 1 ]] && { usage; exit 0; }
312 verbose "Command line arguments: ${GLOBAL_ARGS[@]}"
314 # the remaining args are the features
317 # validate the machine list
318 debug "validating machines list"
321 # validate the machine
322 debug "validating machine $MACHINE"
323 find_machine_dir $MACHINE >/dev/null || error "Machine '$MACHINE' not found in [ $(list_all_machines)]"
325 # validate the features list
326 debug "validating features list"
330 for FEATURE in $FEATURES;do
331 TMP_FEATURES="$TMP_FEATURES $FEATURE"
332 TMP_FEATURES="$TMP_FEATURES $(find_feature_dependency $FEATURE $TMP_FEATURES)"
334 # remove duplicate features if any
335 FEATURES=$(for x in $TMP_FEATURES; do echo $x; done | sort -u | awk '{printf("%s ",$1);}')
337 # validate the features
338 for f in $FEATURES; do
339 debug "validating feature $f"
340 find_feature_dir $f >/dev/null || error "Feature '$f' not found in [ $(list_all_features)]"
344 debug "validating builddir $BUILDDIR"
345 BUILDDIR=$(mkdir -p "$BUILDDIR" && cd "$BUILDDIR" && pwd -P)
348 ###########################################################################################
349 function dump_log() {
350 info " ------------ $(basename $1) -----------------"
352 info " ----------------------------------------"
355 function genconfig() {
356 info "Generating configuration files:"
357 info " Build dir: $BUILDDIR"
358 info " Machine: $MACHINE"
359 info " Features: $FEATURES"
361 # step 1: run usual OE setup to generate conf dir
362 export TEMPLATECONF=$(cd $SCRIPTDIR/../templates/base && pwd -P)
363 debug "running oe-init-build-env with TEMPLATECONF=$TEMPLATECONF"
364 info " Running $METADIR/poky/oe-init-build-env"
365 info " Templates dir: $TEMPLATECONF"
368 . $METADIR/poky/oe-init-build-env $BUILDDIR >/dev/null
371 # step 2: concatenate other remaining fragments coming from base
372 process_fragments $TEMPLATECONF
374 # step 3: fragments for machine
375 process_fragments $(find_machine_dir $MACHINE)
377 # step 4: fragments for features
378 for feature in $FEATURES; do
379 process_fragments $(find_feature_dir $feature)
382 # step 5: sort fragments and append them in destination files
383 FRAGMENTS_BBLAYERS=$(sed 's/ /\n/g' <<<$FRAGMENTS_BBLAYERS | sort)
384 debug "bblayer fragments: $FRAGMENTS_BBLAYERS"
385 info " Config: $BUILDDIR/conf/bblayers.conf"
386 for x in $FRAGMENTS_BBLAYERS; do
388 append_fragment $BUILDDIR/conf/bblayers.conf $file
392 FRAGMENTS_LOCALCONF=$(sed 's/ /\n/g' <<<$FRAGMENTS_LOCALCONF | sort)
393 debug "localconf fragments: $FRAGMENTS_LOCALCONF"
394 info " Config: $BUILDDIR/conf/local.conf"
395 for x in $FRAGMENTS_LOCALCONF; do
397 append_fragment $BUILDDIR/conf/local.conf $file
401 FRAGMENTS_SETUP=$(sed 's/ /\n/g' <<<$FRAGMENTS_SETUP | sort)
402 debug "setup fragments: $FRAGMENTS_SETUP"
403 cat <<EOF >$BUILDDIR/conf/setup.sh
406 # this script has been generated by $BASH_SOURCE
408 export MACHINE="$MACHINE"
409 export FEATURES="$FEATURES"
410 export BUILDDIR="$BUILDDIR"
411 export METADIR="$METADIR"
413 echo "--- beginning of setup script"
415 info " Setup script: $BUILDDIR/conf/setup.sh"
416 for x in $FRAGMENTS_SETUP; do
418 append_fragment $BUILDDIR/conf/setup.sh $file "echo '--- fragment $file'"
421 append_fragment $BUILDDIR/conf/setup.sh "" "echo '--- end of setup script'"
423 infon " Executing setup script ... "
424 execute_setup $BUILDDIR/conf/setup.sh 2>&1 | tee $BUILDDIR/conf/setup.log
425 [[ ${PIPESTATUS[0]} == 0 ]] && {
427 [[ $VERBOSE == 1 ]] && dump_log $BUILDDIR/conf/setup.log
428 rm $BUILDDIR/conf/setup.sh
431 info "FAIL: please check $BUILDDIR/conf/setup.log"
432 dump_log $BUILDDIR/conf/setup.log
435 # NOTE: the setup.sh script is removed if execution succeeded (only the log remains)
438 ###########################################################################################
440 # check for overwrite
441 [[ $FORCE -eq 1 ]] && rm -f \
442 $BUILDDIR/conf/local.conf \
443 $BUILDDIR/conf/bblayers.conf \
444 $BUILDDIR/conf/setup.* \
447 if [[ -f $BUILDDIR/conf/local.conf || -f $BUILDDIR/conf/bblayers.conf ]]; then
448 info "Configuration files already exist:"
449 for x in $BUILDDIR/conf/local.conf $BUILDDIR/conf/bblayers.conf; do
450 [[ -f $x ]] && info " - $x"
452 info "Skipping configuration files generation."
453 info "Use option -f|--force to overwrite existing configuration."
458 # always generate setup script in builddir: it can be sourced later manually without re-running the setup
459 infon "Generating setup file: $BUILDDIR/agl-init-build-env ... "
460 cat <<EOF >$BUILDDIR/agl-init-build-env
461 . $METADIR/poky/oe-init-build-env $BUILDDIR
462 if [ -n "\$DL_DIR" ]; then
463 BB_ENV_EXTRAWHITE="\$BB_ENV_EXTRAWHITE DL_DIR"
465 if [ -n "\$SSTATE_DIR" ]; then
466 BB_ENV_EXTRAWHITE="\$BB_ENV_EXTRAWHITE SSTATE_DIR"
468 export BB_ENV_EXTRAWHITE
473 # finally, generate output script if requested by caller
474 if [[ -n "$SETUPSCRIPT" ]]; then
475 debug "generating setupscript in $SETUPSCRIPT"
476 cat <<EOF >$SETUPSCRIPT
477 . $BUILDDIR/agl-init-build-env
481 info "------------ $SCRIPT: Done"